import 'package:flutter_webrtc/flutter_webrtc.dart';
import 'package:transmedika_one_to_one_call/webrtc/socket_usecase_service.dart';

import 'one_to_one_state.dart';


/// Use Case one to one video call ///
abstract class OneToOneUseCaseService extends SocketUseCaseService{
  Future<void> stop();
  Future<void> register({required String from, required String to, required bool isCalling});
  Future<void> publishCallVideo({required Map<String,dynamic> from, required Map<String,dynamic> to,
    required RTCSessionDescription sessionDescription
  });
  Future<void> publishIncomingCallVideo({
    required Map<String,dynamic> to,
    required RTCSessionDescription sessionDescription,
    Map<String, dynamic>? consultation
  });
  RTCPeerConnection? getPeerConnection();
  Future<void> createLocalPeerConnection({
    required Function(MediaStream stream) onLocalStream,
    required Function(MediaStream stream) onAddRemoteStream,
    required Function(MediaStream stream)? onRemoveRemoteStream
  });
  Future<MediaStream> createStream();
  Future<void> createOffer({
    required Map<String, dynamic> from,
    required Map<String, dynamic> to,
    required bool isCalling,
    Map<String, dynamic>? consultation
  });
  Future<void> iceCandidate(Map<String, dynamic> candidate);
  Future<void> receiveVideoAnswer(String sdpAnswer);
  Future<void> onIceCandidate(RTCIceCandidate rtcIceCandidate);
  Future<void> closeSession();
  Future<void> notifyCaller({required Map<String, dynamic> from, required String to});
  Future<void> reject({required Map<String,dynamic> from, required Map<String,dynamic> to});
  void muteMic();
  void enableVideo();
  void switchCamera({required VideoSource videoSource, required Function(MediaStream stream) onLocalStream});
  Future<void> callingMobileDevice({required String from, required String to, required Map<String, dynamic>? fcm});
  Future<void> selectScreenSource({required VideoSource videoSource, required Function(MediaStream stream) onLocalStream});
}