import 'package:equatable/equatable.dart';


/// enum web socket state ///
enum SocketConnectionState { idle, connecting, open, close, error}

/// class web socket state ///
class SocketState extends Equatable{
  final SocketConnectionState socketConnectionState;
  final String? exception;
  final String? message;
  final Map<String,dynamic>? messageModel;

  const SocketState({
    this.socketConnectionState = SocketConnectionState.idle,
    this.exception,
    this.message,
    this.messageModel
  });

  SocketState copyWith({
    SocketConnectionState? socketConnectionState,
    String? exception,
    String? message,
    Map<String, dynamic>? messageModel
  }) {
    return SocketState(
        socketConnectionState: socketConnectionState ?? this.socketConnectionState,
        exception: exception ?? this.exception,
        message: message ?? this.message,
        messageModel: messageModel ?? this.messageModel
    );
  }

  @override
  List<Object?> get props => [socketConnectionState, exception, message, messageModel];
}